# Simple Discord Stock Bot

Super simple Discord Bot wrote in Python for displaying the price of a stock, or news about a stock quickly and easily.

## Motivation

[Google Allo](https://blog.google/products/messages/latest-messages-allo-duo-and-hangouts/) is disappearing in March 2019 so me and my friends who use it for talking about stocks need a replacement. Allo has a feature that allows you to talk to the Google Assitant right in the chat which makes pulling up a news article or a stock quote in chat extremely easy. This bot aims to replace that specific functionality.

## Features

The bot checks every message for tickers which can be called by putting a dollar sign in front of the stock symbol like this: `$tsla` The bot is pretty smart and can handle as many tickers in a message as you put in.

For example the message:

`I want to know about $tsla $djia $f $aaxn $baba $amzn`

Will output:

![Discord-Bot-Stock-Price-Example](https://blog.ansonbiggs.com/content/images/2019/01/Discord-Bot-Stock-Price-Example.png)

The bot can also quickly give you news links about any tickers you need. Simply putting `!news` in front of your message like this:

`!news $tsla`

Will output:

![Discord-Bot-Stock-News-Example](https://blog.ansonbiggs.com/content/images/2019/01/Discord-Bot-Stock-News-Example.png)

The news feature also works with as many tickers as you want to put in a message at once for example: `!news I want to know about $tsla $amzn`

## How it works

The most important part of the project is [discord.py](https://github.com/Rapptz/discord.py) which is an API wrapper for Discord written in Python. discord.py made this project a breeze.

The other important part is the [Bravos API](https://bravos.co/a/data) which is used to get the current quote for the provided ticker. The API works perfectly and is free with an account.

The news sources are currently hardcoded, and the code simply puts the stock ticker into a URL where its needed to get a page on that specific ticker. The image of the company that is shown in the embeds are taken from Motley Fool without an official API. There's probably a better way to get the images but I couldn't find one easily.
